/*
 * Copyright 2008 CodeWeavers, Aric Stewart
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef TSMHandle
typedef void *TSMHandle;
#endif

/* mactext functions */

int MacNewTSMDocument(TSMHandle handle, long refcon);
int MacTSMEventCFS(TSMHandle handle, char theChar, unsigned long
			theCode, unsigned long modifiers, unsigned long unichar, void* hIMC);
TSMHandle MacInitTSMAwareApplication(void);
void MacCloseTSMAwareApplication(TSMHandle handle);
int MacTSMFixTextService(TSMHandle handle);
int MacActivateTSMDocument(TSMHandle handle);
int MacTSMRevertToPreviousMode(TSMHandle handle);
int MacTSMCheckModeAndIME(TSMHandle handle);
void MacRemoveAppEventHandler(TSMHandle handle);
void MacInstallAppEventHandler(TSMHandle handle);

/* toAscii */
int XToAscii(UINT uVKey, UINT keysym, UINT keycode, CONST LPBYTE lpbKeyState,
    LPDWORD lpdwTransKey, void* hIMC);
int MacToAscii(UINT uVKey, WCHAR unichar, char theChar, unsigned long theCode, CONST LPBYTE lpbKeyState, LPDWORD lpdwTransKey, void* hIMC);

/* IME support */
void IME_RegisterClasses(HINSTANCE hImeInst);
void IME_UnregisterClasses(HINSTANCE hImeInst);
void IME_SetOpenStatus(BOOL fOpen);
LRESULT IME_SendMessageToSelectedHWND(UINT msg, WPARAM wParam, LPARAM lParam);
INT IME_GetCursorPos( void );
void IME_UpdateAssociation(HWND focus);
void IME_SetCompositionString(void* hIMC, LPCVOID lpComp, DWORD dwCompLen);
BOOL IME_NotifyIME( void );

/* MAC */
void MAC_SetupXIM( void );

/* Server */
TSMHandle Server_Init(void);
int Server_MacTSMCheckModeAndIME(void);
void Server_MacTSMFixTextService(void);
void Server_MacTSMRevertToPreviousMode(void);
int Server_XToAscii(UINT uVKey, UINT keysym, UINT keycode, CONST LPBYTE lpbKeyState,
    LPDWORD lpdwTransKey, void* hIMC);
int Server_MacToAscii(UINT uVKey, WCHAR unichar, char theChar, unsigned long theCode, CONST LPBYTE lpbKeyState, LPDWORD lpdwTransKey, void* hIMC);

void Server_Shutdown(void);
void PumpEvents( void );
